package rescuecore2.standard.entities;

import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import seu.states.PoliceForceState;

/**
   The PoliceForce object.
 */
public class PoliceForce extends Human {
	
	protected PoliceForceState state;
	/**
	 * @return State
	 */
	public PoliceForceState getState() {
		return state;
	}
    /**
       Construct a PoliceForce object with entirely undefined values.
       @param id The ID of this entity.
    */
    public PoliceForce(EntityID id) {
        super(id);
        state = new PoliceForceState(this);
    }

    /**
       PoliceForce copy constructor.
       @param other The PoliceForce to copy.
     */
    public PoliceForce(PoliceForce other) {
        super(other);
    }

    @Override
    protected Entity copyImpl() {
        return new PoliceForce(getID());
    }

    @Override
    public StandardEntityURN getStandardURN() {
        return StandardEntityURN.POLICE_FORCE;
    }

    @Override
    protected String getEntityName() {
        return "Police force";
    }
}
