package rescuecore2.standard.entities;

import rescuecore2.worldmodel.Entity;
import rescuecore2.worldmodel.EntityID;
import seu.states.PoliceOfficeState;

/**
   The PoliceOffice object.
 */
public class PoliceOffice extends Building {
	
	protected PoliceOfficeState state;
	
	/**
	 * @return State
	 */
	public PoliceOfficeState getState() {
		return state;
	}
    /**
       Construct a PoliceOffice object with entirely undefined property values.
       @param id The ID of this entity.
     */
    public PoliceOffice(EntityID id) {
        super(id);
        state  = new PoliceOfficeState(this);
    }

    /**
       PoliceOffice copy constructor.
       @param other The PoliceOffice to copy.
     */
    public PoliceOffice(PoliceOffice other) {
        super(other);
    }

    /**
       Create a police office based on another Building.
       @param other The Building to copy.
     */
    public PoliceOffice(Building other) {
        super(other);
    }

    @Override
    protected Entity copyImpl() {
        return new PoliceOffice(getID());
    }

    @Override
    public StandardEntityURN getStandardURN() {
        return StandardEntityURN.POLICE_OFFICE;
    }

    @Override
    protected String getEntityName() {
        return "Police office";
    }
}
