
package seu.agent;

/**
 * Seu Agent Constants
 * 
 * @author JiangYh
 *  
 */
public interface Constants {
    static final int
        TIME_INITIALIZING_AGENT = Integer.MIN_VALUE, // [cycle]
        TIME_STARTING_ACTION = 3, // [cycle]
        UTTERANCE_LIMIT = 4, // [message/cycle]
        HEARING_LIMIT_OF_HUMANOID = 4; // [message/cycle]

    /** @see "<code>period</code> of the RUN/config.txt" */
    static final int SIMULATING_TIME = 300; // [cycle]

    /** @see "<code>max_extinguish_length</code> of the kernel/parameters.hxx"
     */
    static final int EXTINGUISHABLE_DISTANCE = 30 * 1000; // [mm]

    /** @see "<code>voice</code> of the boot/config.txt"
     */
    static final int HEAR_DISTANCE = 30 * 1000; // [mm]

    /** @see "<code>vision</code> of the boot/config.txt"
     */
    static final int SEE_DISTANCE = 10 * 1000; // [mm]

    /** @see "<code>max_extinguish_power</code> of the kernel/parameters.hxx"
     */
    static final int EXTINGUISHABLE_QUANTITY = 1000; // [0.001 m^3]

    public static final int REST_ACT= 0x80;
    public static final int MOVE_ACT = 0x81;
    public static final int LOAD_ACT= 0x82;
    public static final int UNLOAD_ACT = 0x83 ;
    public static final int EXTINGUISH_ACT = 0x86;
    public static final int RESCUE_ACT =  0x88;
    public static final int CLEAR_ACT = 0x89;
    
    public static final int HELPER_AT = 0;
    public static final int HELPER_PF = 1;
    public static final int HELPER_FB = 2;
    
    public static final float WOOD_ENERGIE = 1200f;  //400f
    public static final float STEEL_ENERGIE = 800.0f; //110f;
    public static final float CONCRETE_ENERGIE = 350.0f; //10f
    
	public static final float WOOD_CAPACITY= 1.1f ;//1f;
	public static final float STEEL_CAPACITY= 1.0f; //1f;
	public static final float CONCRETE_CAPACITY= 1.5f;//4f;
	
	public static final float WOOD_IGNITION= 47f; // 60f;
	public static final float STEEL_IGNITION=47f; //60f;
	public static final float CONCRETE_IGNITION= 47f; //104f;
	
	
	public static final float RADIATION_COEFFICENT = 0.0023f; //0.005f;
	public static final float WATER_COEFFICIENT = 135.0f; //10f;
	public static final float DELTA = 0.1f;
	
	public static final float INITIAL_TEMPERATURE = 20f;
	public static final int INITIAL_FIRE_CYCLES = 400;
	public static final float TEMPERATURE_BOUND = 50f;
	public static final float CONVECTION_RATE = 0.0005f;
	public static final float ENERGY_LOSS_RATE = 0.01f;
	
	public static final boolean BUILDING_PREDICTION_DEBUG = false;
	public static final boolean WATER_DEBUG = false;
	public static final boolean CONVETION_DEBUG = false;
	public static final boolean BURNING_DEBUG = false;
	
	
	public static final String WATER_LOG= "water" ;
	public static final String PREDICTION_LOG = "prediction";
	public static final String CONVECTION_LOG = "convection";
}
