/**
 * 2010-6-12
 * @author
 *
 */
package seu.entities;

import java.util.Iterator;

import rescuecore2.standard.entities.StandardWorldModel;
import seu.SeuConstants;

/**
 * @author robocup
 *
 */
public class BlockedPath {
	
	public Path m_path;
	public final double coefFiredBuildings = 2.5;
	public final double coefIsRefugeOn = 12.0;
	public final double coefIsPrevTask = 6.0;
	public final double coefTrappedCivilian = 3.5;
	public final double coefTrappedAgent = 12.0;
	public final double coefCivExpectation = 1.3;
	
	public int numOfRefuges = 0;
	public int numOfTrappedCivilian = 0;
	public int numOfTrappedAgent = 0;
	
	public int numOfFiredBldgs = 0;
	
	public int isPrevTask = 0;
	
	public double civValue = 0;
	
	private double value = 100;
	public float directDistance = 100000;
	
	
	public float additional;
	
	public double civExpectation = 0;
	
	public BlockedPath(Path path)
	{
		m_path = path;
		if(path != null)
			calculateCivEvaluation();
	}
	
	private void calculateCivEvaluation(){
		for(Iterator<Node> it = m_path.getContainedNodes().iterator(); it.hasNext();){
			Node node = it.next();
			
			civExpectation += node.civPossiblity;
			
		}
	}
	
	public void calculateValue(boolean considerDist){
		
		value += numOfFiredBldgs*coefFiredBuildings
				+ numOfRefuges*coefIsRefugeOn
				+ isPrevTask*coefIsPrevTask
				+ numOfTrappedAgent*coefTrappedAgent
				+ numOfTrappedCivilian*coefTrappedCivilian;
		
//		if(isRadioChannelCollapsed||world.getTime()>=20) value+=numOfTrappedAgent*coefTrappedAgent;
		
		value += additional;
		
		value += civValue;
		
		value += civExpectation*coefCivExpectation;
		
		
		if(!considerDist)
			return;
		
		double dist = directDistance;
		dist /= 180000;
		dist += 6;
		if (value>100)
			value = value/dist;
		else
			value = -1;		
	}
	
	public double getValue(){
		return value;
	}
	
	
}
