/**
 * 2010-5-18
 * @author Jiang Yinhao
 *
 */
package seu.entities;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;

/**
 * @author Jiang Yinhao
 * 
 */
public class Node {

	private EntityID neighbour;
	private EntityID entityID;
	private Edge me;

	public Node(StandardEntity entity, Edge ed) {
		this.me = ed;
		neighbour = ed.getNeighbour();
		entityID = entity.getID();
	}

	/**
	 * @return EntityID of E By JiangYh 2010-5-18
	 */
	public EntityID getEntity() {
		return entityID;
	}

	/**
	 * @return By JiangYh 2010-5-18
	 */
	public ArrayList<Road> getConnectedRoads(StandardWorldModel world) {
		ArrayList<Road> rds = new ArrayList<Road>();
		if (world.getEntity(neighbour) instanceof Road) 
			rds.add((Road) world.getEntity(neighbour));
		return rds;
	}

	/**
	 * @return By JiangYh 2010-5-18
	 */
	public ArrayList getConnectedBuildings(StandardWorldModel world) {
		ArrayList bds=new ArrayList<Building>();
		if (world.getEntity(neighbour) instanceof Building)
			bds.add((Building) world.getEntity(neighbour));
		return bds;
	}

	public Edge me() {
		return me;
	}

	public StandardEntity getNeighborhood(StandardWorldModel world) {
		return world.getEntity(neighbour);
	}

	private List<Path> m_containedPaths = null;

	/**
	 * @return contained paths By JiangYh 2010-6-11
	 */
	public Collection<Path> getContainedPaths(StandardWorldModel world) {
		if (m_containedPaths == null) {
			m_containedPaths = new ArrayList<Path>();
			for (Path path : world.getState().paths) {
				if (path.getContainedRoads().contains(this)) {
					m_containedPaths.add(path);
				}
			}
		}
		return m_containedPaths;
	}

	public double civPossiblity = 0;

	/**
	 * @return By JiangYh 2010-6-12
	 */
	public int getX() {
		return (me.getEndX() + me.getStartX()) / 2;
	}

	public int getY() {
		return (me.getEndY() + me.getStartY()) / 2;
	}

	/**
	 * @param x
	 * @param y
	 * @return
	 */
	public boolean isNode(int x, int y) {
		// TODO Auto-generated method stub
		return (getX() == x && getY() == y);
	}
}
