//SEU2010

package seu.messages;

import java.util.Map;

import rescuecore2.standard.entities.*;

public class GiveWayMessage extends SEUMessage {
	static final int Size = 1;
	
	//isGive = 1: is give; 0 : not give.
	
	public GiveWayMessage() {
		super(Type.GIVE_WAY_REPORT, null);
	}
	
	public GiveWayMessage(char[] message) {
		super(Type.GIVE_WAY_REPORT, null);
		this.lifeCycle = Util.charArrayToint(message, Size, lifeCycle);
	}

	@Override
	public boolean equals(Object m) {
		if(!(m instanceof GiveWayMessage)){
			return false;
		}
		return lifeCycle==((GiveWayMessage)m).lifeCycle;
	}

	@Override
	public int hashCode() {
		return lifeCycle;
	}
	 
	@Override
	protected int length() {
		return staticLength();
	}
	
	static protected int staticLength()
	{
		return lifeSize;
	}
	
	@Override
	char[] toCharArray(Map ids) {
		char[] result = new char[length()];
		
		char[] temp = Util.intToCharArray(lifeCycle, lifeSize);
		Util.copyArray(temp, result, 0, 0, lifeSize);		
		
       return result;
	}

	@Override
	public boolean updateWorld(StandardWorldModel world, int time) {
		if(world.getState().me instanceof AmbulanceTeam){
			AmbulanceTeam self = (AmbulanceTeam) world.getState().me;
			self.getState().updateGiveWay(true);
		}
		else if(world.getState().me instanceof FireBrigade){
			FireBrigade self = (FireBrigade) world.getState().me;
			self.getState().updateGiveWay(true);
		}
		return false;
	}


}
