package seu.messages;

import seu.messages.Type;

public interface MessageConstants{
	
//	static final int MAX_LENGTH = 256;
    static final int HEADER_SIZE = 5;   
    static final int LENGTH_SIZE = 8;   

    static final int HEADER_NULL = 0;
    static final int HEADER_FIRE = 1;
    static final int HEADER_VICTIM = 2;
    static final int HEADER_ROAD = 3;
    static final int HEADER_POSITION = 4;
    
    static final int HEADER_LOCKEDBYBLOCKADE = 5;
    static final int HEADER_UNLOCKEDBYBLOCKADE = 6;
    
    static final int HEADER_ASSIGN_RESCUE_TARGET = 7;
    static final int HEADER_ASSIGN_CLEAR_TARGET = 8;
    static final int HEADER_ASSIGN_EXTINGUISH_TARGET = 9;

    static final int HEADER_FOUND_CIVILIAN = 19;
    
    static final int HEADER_AIS_COEFFICIENT = 21;

    static final int HEADER_HEARD_CIVILIAN = 10;
    
    static final int HEADER_GIVE_WAY = 11;
    
    static final int HEADER_FIRE_WATER = 25;
    static final int HEADER_REMAINED_WATER = 26;
    
    static final int HEADER_EMPTYBUILDING = 27;
    
    static final int ID_SIZE = 14;
    static final int LIFE_SIZE = 3;
    
    
    
	public static final Type ROAD_REPORT = new Type("R", HEADER_ROAD);
	public static final Type FIRE_REPORT = new Type("F", HEADER_FIRE);
	public static final Type VICTIM_REPORT = new Type("V", HEADER_VICTIM);
	
    public static final Type POSITION_REPORT = new Type("P", HEADER_POSITION);
    public static final Type LOCKEDBYBLOCKADE_REPORT = new Type("L", HEADER_LOCKEDBYBLOCKADE);
    public static final Type UNLOCKEDBYBLOCKADE_REPORT = new Type("U", HEADER_UNLOCKEDBYBLOCKADE);
    
    public static final Type AIS_COEFFICIENT_REPORT = new Type("m", HEADER_AIS_COEFFICIENT);
    public static final Type FOUND_CIVILIAN_REPORT = new Type("FC", HEADER_FOUND_CIVILIAN);
    
    public static final Type HEARD_CIVILIAN_REPORT = new Type("HC", HEADER_HEARD_CIVILIAN);
    
    public static final Type ASSIGN_RESCUE_TARGET_REPORT = new Type("AR", HEADER_ASSIGN_RESCUE_TARGET);
    public static final Type ASSIGN_CLEAR_TARGET_REPORT = new Type("AC", HEADER_ASSIGN_CLEAR_TARGET);
    public static final Type ASSIGN_EXTINGUISH_TARGET_REPORT = new Type("AE", HEADER_ASSIGN_EXTINGUISH_TARGET);
    
    public static final Type FIRE_WATER_REPORT = new Type("FW", HEADER_FIRE_WATER);
    public static final Type REMAINED_WATER_REPORT = new Type("RW", HEADER_REMAINED_WATER);
    
    public static final Type EMPTYBUILDING_REPORT = new Type("E", HEADER_EMPTYBUILDING);
    
    public static final Type GIVE_WAY_REPORT = new Type("G", HEADER_GIVE_WAY);
    
	
    //TODO
    public static int AGENT_MSG_COUNT = 0;
    public static int STATION_MSG_COUNT = 0;

	public static int MAX_MESSAGE_COUNT = 4;
	static final int SAY_MSG_COUNT = 4;
	
	static final int CHANNEL_SAY = 0;
    static final int CHANNEL_CENTERS = 1;
    static final int CHANNEL_AGENTS = 2;
    static final int CHANNEL_POLICEOFFICE = 3;
    static final int CHANNEL_AMBULANCECENTER = 4;
    static final int CHANNEL_FIRESTATION = 5;
    static final int CHANNEL_POLICEFORCE = 6;
    static final int CHANNEL_AMBULANCETEAM = 7;
    static final int CHANNEL_FIREBRIGADE = 8;
}