//SEU2010

package seu.messages;

import java.util.Map;

import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardWorldModel;
import seu.messages.MessageConstants;
import seu.messages.Type;

public abstract class SEUMessage implements MessageConstants{
	
	public Type type;
    static final int idSize = ID_SIZE;
    static final int lifeSize = LIFE_SIZE;
    protected StandardEntity obj;
    protected int lifeCycle ;
    
	protected SEUMessage(Type type, StandardEntity obj)
    {
        this.type = type;
        this.obj = obj;
        this.lifeCycle=1;			//1 cycle's delay is needed
    }
	
	abstract char[] toCharArray(Map ids);

    protected abstract int length();

    public abstract boolean equals(Object m);

    public abstract int hashCode();

    public abstract boolean updateWorld(StandardWorldModel world , int time);
    
    public int getLife(){
    	return lifeCycle;
    }
    
    public int incrementLife(){
    	return ++lifeCycle;
    }
    
}