package seu.messages;

import java.util.Collections;
import java.util.Map;

import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.StandardWorldModel;
import seu.messages.Util;
import seu.messages.Type;

public class UnLockedByBlockadeMessage extends SEUMessage{

	private final int senderIndex;
	static final int indexSize = 7;
	
	public UnLockedByBlockadeMessage(int senderIndex)
    {
        super(Type.UNLOCKEDBYBLOCKADE_REPORT, null);
        this.senderIndex = senderIndex;
    }

	public UnLockedByBlockadeMessage(char[] message)
    {
        super(Type.UNLOCKEDBYBLOCKADE_REPORT, null);
        this.senderIndex = Util.charArrayToint(message, 0, indexSize);
        this.lifeCycle = Util.charArrayToint(message, indexSize, lifeSize);
    }
	
	@Override
	public boolean equals(Object m) {
		if (!(m instanceof UnLockedByBlockadeMessage)) return false;
		return ((UnLockedByBlockadeMessage)m).senderIndex == senderIndex;
	}

	@Override
	public int hashCode() {
		return senderIndex;
	}

	@Override
	protected int length() {
		return staticLength();
	}

	public static int staticLength(){
		return indexSize + lifeSize;
	}
	
	@Override
	char[] toCharArray(Map idToVirtualIds) {
		char[] result = new char[length()];
		
		char[] temp = Util.intToCharArray(senderIndex, indexSize);
		Util.copyArray(temp, result, 0, 0, indexSize);
		
		temp = Util.intToCharArray(lifeCycle, lifeSize);
		Util.copyArray(temp, result, 0, indexSize, lifeSize);
		
		return result;
	}

	@Override
	public boolean updateWorld(StandardWorldModel world, int time) {
		Collections.sort(world.getState().agents, seu.agent.Util.idComparator);
		Human hum = (Human)world.getState().agents.get(senderIndex);
		if(world.getState().lockedByBlockadeAgentMap.containsKey(hum.getID().getValue())){
			world.getState().lockedByBlockadeAgentMap.remove(hum.getID().getValue());
			if(hum instanceof AmbulanceTeam){
    			AmbulanceTeam at = (AmbulanceTeam) hum;
    			at.getState().setWereLockedByBlockade(world, false);
    			return true;
    		}
    		else if(hum instanceof FireBrigade){
    			FireBrigade fb = (FireBrigade) hum;
    			fb.getState().setWereLockedByBlockade(world, false);
    			return true;
    		}
		}
		
		return false;
	}
}