//SEU2010

package seu.states;

import java.util.ArrayList;
import java.util.List;

import rescuecore2.standard.entities.*;
import seu.SeuConstants;

public class AmbulanceTeamState extends HumanState {
	
	private AmbulanceTeam me;
	
	public AmbulanceTeamState(AmbulanceTeam me) {
		super(me);
		mCoeList.add(new Integer(150));
		mCoeList.add(new Integer(280));
		mCoeList.add(new Integer(500));
		mCoeList.add(new Integer(320));
		mCoeList.add(new Integer(120));
		mCoeList.add(new Integer(180));
		mCoeList.add(new Integer(800));
		mCoeList.add(new Integer(400));
		
		m1 = mCoeList.get(0);
		m2 = mCoeList.get(1);
		m3 = mCoeList.get(2);
		m4 = mCoeList.get(3);
		m5 = mCoeList.get(4);
		
		mc1 = mCoeList.get(5);
		mc2 = mCoeList.get(6);
		mc3 = mCoeList.get(7);
		
	    micoe1 = exchange(m1);
		micoe2 = exchange(m2);
		micoe3 = exchange(m3);
		micoe4 = exchange(m4);
		micoe5 = exchange(m5);
			
		mlkcoe1 = exchange(mc1);
		mlkcoe2 = exchange(mc2);
		mlkcoe3 = exchange(mc3);
	}
	
//	public int getType(){
//		return SeuConstants.TYPE_AMBULANCE_TEAM;
//	}
	
	protected Civilian m_centerAssigned;
	
	protected Civilian m_centerSecondAssigned;
	
	public Civilian myCurrentTarget;
	
	public Civilian mySelectedTarget = null;
	
	
	//TODO
//	public AmbulanceTeamState clone(DisasterSpace world){
//		AmbulanceTeamState r =  new AmbulanceTeamState(this.id,world);
//		cloneTo(r);
//		return r;
//	}

	private int m_centerAssignedTime = -1;
	
	public int getCenterAssignedTime(){
		return m_centerAssignedTime;
	}
	
	public void setCenterAssignedTarget(Civilian target, int time) {
		m_centerAssigned = target;
		if(target != null)
			m_centerAssignedTime = time;
	}

	public void setCenterSecondAssignedTarget(Civilian target, int time) {
		m_centerSecondAssigned = target;
		if(target != null && time > m_centerAssignedTime)
			m_centerAssignedTime = time;
	}
	
	public Civilian getCenterAssignedTarget(){
		return m_centerAssigned;
	}

	public Civilian getCenterSecondAssignedTarget(){
		return m_centerSecondAssigned;
	}
	
	private int m_assignedTime = -1;
	
	public void setAssignedCycle(int time){
		m_assignedTime = time;
	}
	public boolean isAssignedCurrentCycle(StandardWorldModel world){
		return m_assignedTime == world.getState().getTime();
	}
	
	public Civilian currentTarget = null;

	public Civilian nextTarget = null;
	
	public Human lockedTarget = null;
	
	public Civilian lastTarget = null;
	
	public void setNextTarget(Civilian nextTarget) {
		this.nextTarget = nextTarget;
	}
	
	public void updateCurrentTarget() {
		currentTarget = nextTarget;
	}

	public Human getCurrentTarget(StandardWorldModel world) {
		if(currentTarget == null && world.getState().civilians.size() != 0)
			currentTarget = world.getState().civilians.get(0);
		return currentTarget;
	}

	public Human getNextTarget() {
		return nextTarget;
	}
	
	public Civilian getLastTarget(){
		return this.lastTarget;
	}
	
	public void setLastTarget(Civilian lastTarget){
		this.lastTarget = lastTarget;
	}
	
	public boolean isBusyNow(StandardWorldModel world){
		boolean isBusy = false;
		if(world.getState().me != me){
			if(me.getPosition(world) instanceof Refuge) return false;
			List<Human> toRescue = new ArrayList<Human>(world.getState().buriedAgents);
			toRescue.addAll(world.getState().civilians);
			for(Human hum : toRescue){
				if(hum.getPosition(world) instanceof Road) continue;
				if(hum instanceof Civilian){
					Civilian civ = (Civilian) hum;
					if(civ.getPosition(world)!= null 
							&& (civ.getState().needLoad(world)||civ.getState().needRescue(world)) 
							&&civ.getPosition(world) == me.getPosition(world)){
						isBusy = true;
						break;
					}
				}
				else if(hum instanceof AmbulanceTeam){
					AmbulanceTeam at = (AmbulanceTeam) hum;
					if(at.getPosition(world)!= null 
							&& (at.getState().needLoad(world)||at.getState().needRescue(world)) 
							&& at.getPosition(world) == me.getPosition(world)){
						isBusy = true;
						break;
					}
				}
				else if(hum instanceof FireBrigade){
					FireBrigade fb = (FireBrigade) hum;
					if(fb.getPosition(world)!= null 
							&& (fb.getState().needLoad(world)||fb.getState().needRescue(world)) 
							&& fb.getPosition(world) == me.getPosition(world)){
						isBusy = true;
						break;
					}
				}
				else if(hum instanceof PoliceForce){
					PoliceForce pf = (PoliceForce) hum;
					if(pf.getPosition(world)!= null 
							&& (pf.getState().needLoad(world)||pf.getState().needRescue(world)) 
							&& pf.getPosition(world) == me.getPosition(world)){
						isBusy = true;
						break;
					}
				}
			}
			return isBusy;
		}
		else{
			if(me.getState().mySelectedTarget != null) return true;
			else return false;
		}
	}
	
	private int m1,m2,m3,m4,m5;
	private int mc1,mc2,mc3;
	
	public ArrayList<Integer> mCoeList = new ArrayList<Integer>();
	
	public float micoe1 = 0.15f,micoe2 = 0.28f,micoe3 = 5f,micoe4 = 0.32f,micoe5 = 0.12f;
	public float mlkcoe1 = 1.8f,mlkcoe2 = 0.8f,mlkcoe3 = 0.4f;
	
	public void UpdateCoe(){
		
		m1 = mCoeList.get(0);
		m2 = mCoeList.get(1);
		m3 = mCoeList.get(2);
		m4 = mCoeList.get(3);
		m5 = mCoeList.get(4);
		
		mc1 = mCoeList.get(5);
		mc2 = mCoeList.get(6);
		mc3 = mCoeList.get(7);
		
	    micoe1 = exchange(m1);
		micoe2 = exchange(m2);
		micoe3 = exchange(m3);
		micoe4 = exchange(m4);
		micoe5 = exchange(m5);
			
		mlkcoe1 = exchange(mc1);
		mlkcoe2 = exchange(mc2);
		mlkcoe3 = exchange(mc3);
		
	}
	protected float exchange(int i)
	{
		float j;
		j=i*0.001f;
		return j;
	}

}
