//SEU2010

package seu.states;

import java.util.LinkedList;

import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.Property;
import seu.agent.Constants;
import seu.agent.Util;
import seu.entities.ExtraProperty;
import seu.entities.Report;
import seu.utilities.AgentUtil;
import seu.utilities.base.SingleData;

public abstract class EntityState {
	protected StandardEntity me;

	public Report report = new Report();

	public EntityState(StandardEntity me) {
		this.me = me;
	}

//	abstract public int getType();

	private int m_time;

	public void setTime(int time) {
		m_time = time;
	}

	public int getTime() {
		return m_time;
	}

	public boolean shouldUpdate(int time) {
		return time > m_time;
	}

	public boolean isVisible(StandardWorldModel world) {
		return (getTime() == world.getState().getTime());
	}

	public void setProperty(StandardWorldModel world, int time, Property type , Object value) {

	}

	public int getDistance(StandardEntity to) {
		return AgentUtil.distance(me, to);
	}

	public boolean hasBeenSeen() { // Since time() Is The Time Of Last Seeing ,
		// This Method Is Correct
		return getTime() >= Constants.TIME_STARTING_ACTION;
	}

	// -------------------------------------------------------------------
	// action
	private LinkedList<SingleData<Integer>> m_actionType = new LinkedList<SingleData<Integer>>();

	// private byte[] m_actionData;
	private LinkedList<SingleData<byte[]>> m_actionData = new LinkedList<SingleData<byte[]>>();

	public void updateAction(StandardWorldModel world, int type,
			byte[] actionData, int time) {
		if (m_actionType.size() >= world.getState().getParameter().LIST_LENGTH_ACTION) {
			m_actionType.removeFirst();
			m_actionData.removeFirst();
			m_actionData.addLast(new SingleData<byte[]>(actionData, time));
			m_actionType.addLast(new SingleData<Integer>(type, time));
		} else {
			m_actionType.addLast(new SingleData<Integer>(type, time));

			m_actionData.addLast(new SingleData<byte[]>(actionData, time));
		}

	}

	public int getActionType() {
		return m_actionType.getLast().getObject();
	}

	public int getActionType(int time) {
		return Util.searchSingleDataForTime(m_actionType, time);
	}

	public byte[] getActionData() {
		return m_actionData.getLast().getObject();
	}

	public byte[] getActionData(int time) {
		return Util.searchSingleDataForTime(m_actionData, time);
	}

	public final ExtraProperty distancePrp = new ExtraProperty() {
		public Object eval(Object obj) {
			if (obj instanceof StandardEntity)
				return new Integer(getDistance((StandardEntity) obj));

			else
				throw new Error("WHA!");
		}
	};
}
