//SEU2010

package seu.states;

import rescuecore2.standard.entities.*;
import rescuecore2.worldmodel.Property;
import seu.SeuConstants;
import seu.utilities.FireSite;

public class FireBrigadeState extends HumanState{

	private FireBrigade me;
	
	public FireBrigadeState(FireBrigade me) {
		super(me);
		this.me = me;
	}
	
//	public int getType(){
//		return SeuConstants.TYPE_FIRE_BRIGADE;
//	}

	private int m_waterQuantity;

	public boolean isTargetAssigned = false;

	int m_distanceToTargetBuilding;

	/**
	 * @return the m_distanceToTargetBuilding
	 */
	public int getDistanceToTargetBuilding(){
		return m_distanceToTargetBuilding;
	}

	public void setDistanceToTargetBuilding(StandardWorldModel world, Building b){
		m_distanceToTargetBuilding = world.getDistance(me, b);
	}

	public int getWaterQuantity(){
		return m_waterQuantity;
	}

	public void setWaterQuantity(int value){
		m_waterQuantity = value;
	}

	private Building m_centerAssignedTarget = null;

	public void setCenterAssignedTarget(Building target){
		m_centerAssignedTarget = target;
	}

	public Building getCenterAssignedTarget(){
		return m_centerAssignedTarget;
	}

	@Override
	public void setProperty(StandardWorldModel world, int time, Property type, int[] value)
	{
		if(type == me.getWaterProperty()){
			setWaterQuantity(value[0]);
		}
		else{
			super.setProperty(world, time, type, value);
		}
	}

	/**
	 * @return target site
	 */
	private FireSite m_centerAssigned = null;

	@SuppressWarnings("unused")
	private int m_centerAssignedTime;

	public void setCenterAssighedTarget(FireSite fs, int time)
	{
		m_centerAssigned = fs;
		m_centerAssignedTime = time;
	}

	public FireSite getCenterAssighedTarget()
	{
		return m_centerAssigned;
	}
}
