//SEU2010

package seu.states;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Blockade;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Human;
import rescuecore2.standard.entities.PoliceForce;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.standard.entities.Road;
import seu.SeuConstants;
import seu.entities.BlockedPath;
import seu.entities.Path;
import seu.utilities.AgentUtil;
import seu.utilities.Partition.RadialPartition;


public class PoliceForceState extends HumanState {
	
	private PoliceForce me;
	
	public PoliceForceState(PoliceForce me) {
		super(me);
		this.me = me;
	}
	
//	public int getType(){
//		return SeuConstants.TYPE_POLICE_FORCE;
//	}

	//TODO
	//check Blockade or Road
	protected Area m_centerAssigned;
	protected Area m_centerSecondAssigned;
	public Area myCurrentTarget = null;
	public Area lastTarget = null;
	public Area nextTarget = null;
	
	

	public Map<Path, BlockedPath> mapBlockedPaths;


	public RadialPartition myClearPartition = null;

	public List<RadialPartition> clearPartitions;
	
	private int m_centerAssignedTime = -1;
	
	public int getCenterAssignedTime(){
		return m_centerAssignedTime;
	}
	
	public void setCenterAssignedTarget(Area target, int time){
		m_centerAssigned = target;
		m_centerAssignedTime = time;
	}
	
	public Area getCenterAssignedTarget(){
		return m_centerAssigned;
	}
	
	public void setCenterSecondAssignedTarget(Area target){
		m_centerSecondAssigned = target;
	}
	
	public Area getCenterSecondAssignedTarget(){
		return m_centerSecondAssigned;
	}

	/**
	 * 
	 * By JiangYh 2010-6-12
	 */
	public void initBlkPath() {
		mapBlockedPaths = new HashMap<Path,BlockedPath>();
		blockedPaths = new ArrayList<BlockedPath>();
	}


	public Path targetPath = null;
	public List<BlockedPath> blockedPaths;
	
	public int getDirectDistance(Path p,StandardWorldModel world)
	{
		Area mlo=null;
		if(((Human)me).getPosition(world) instanceof Area)
			mlo=(Area)((Human)me).getPosition(world);
		
		if (mlo instanceof Building)
			for(Edge eg:((Building)mlo).getEdges())
				if(eg.isPassable() && world.getEntity(eg.getNeighbour()) instanceof Road)
					mlo=(Road) world.getEntity(eg.getNeighbour());
		
		if(p.isOnPath(mlo))
			return 0;
		
		return Math.min(AgentUtil.distance(me, p.getHeadNode()), AgentUtil.direction(me, p.getTailNode()));
	}

	public double randomCoef=0;
	
	 public static class blockedPathComparator implements Comparator<BlockedPath>{
			public int compare(BlockedPath o1, BlockedPath o2) {
				if (o1.getValue() > o2.getValue())
					return -1;
				else
					return 1;
			}
		 }
	
}
