/**************************************************************************
 * Copyright (C) 2010 Knight Guan <Knight.Guan@gmail.com>
 * All rights reserved.
 * Edited by Southeast University RoboCup.
 **************************************************************************
 * Last modify:
 * $Id: FireSite.java,v 2.0 2010 16:56 Knight Exp $
 * 
 * $Id: FireSite.java,v 2.0 2010 10:19 Knight Exp $
 * orldState
 */
package seu.utilities;

import java.awt.Point;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.FireBrigade;
import rescuecore2.standard.entities.StandardWorldModel;
import seu.agent.Util;
import seu.entities.Path;
import seu.states.WorldState;

public class FireSite implements ConstantConditions {

	// Fire Zone
	// private final List<FireZone> totalFireZones = new ArrayList<FireZone>();
	//
	// public HashSet<FireZone> m_containedZones = new HashSet<FireZone>();
	//	
	// public HashSet<Building> m_zonesBuildings = new HashSet<Building>();

	public final StandardWorldModel world;
	
	public final WorldState wst;

	public FireSite(Building fire, StandardWorldModel world) {

		fires.add(fire);

		this.world = world;
		this.wst = world.getState();

		ArrayList<Building> inDangerNeighbors = fire.getState()
				.inDangerNeighbors();
		if (inDangerNeighbors != null && inDangerNeighbors.size() > 0) {
			dangerousFires.add(fire);
		}

		// Guan Daqi add for fire zone
		// this.totalFireZones.clear();
		// this.totalFireZones.addAll(totalFireZones);
		//

		// m_containedZones.add(world.zoneMap.get(fire));
		// m_zonesBuildings.addAll(world.zoneMap.get(fire).getBuildings());

		siteNighbors.addAll(fire.getState().connectedBuildings);

	}

	private boolean isReachable = false;

	public int ignitTime = 0;

	private final HashSet<Path> connectedPaths = new HashSet<Path>();

	private final HashSet<Building> fires = new HashSet<Building>();

	private final HashSet<Building> dangerousFires = new HashSet<Building>();

	private final HashSet<Building> siteNighbors = new HashSet<Building>();

	private int totalFieryness;

	private float totalArea;

	private float burningAreas;

	private float totalAreasAvg;

	public boolean isPutOff = false;

	public boolean isIgniteAgain = false;

	public boolean isIgnitionTimeSet = false;

	public int burningTime = 0;

	public int putOffTime = 300;

	public boolean isPutOffTimeSet = false;

	private boolean needColdDown = false;

	// the smaller the best, choose fire site
	private float siteValue = -1.0f;

	//
	public ArrayList<FireBrigade> fireBrigadesWorkingOn = new ArrayList<FireBrigade>();

	//
	public double totalFierinessArea = 0;

	// the time sense the situation of the firesite
	public int sensingTime = 0;
	public boolean isSensingTimeSet = false;

	//
	// public FireZone getFireZoneOfBuilding(Building b) {
	// for (Iterator<FireZone> it = totalFireZones.iterator(); it.hasNext();) {
	// FireZone fz = it.next();
	// if (fz.contain(b))
	// return fz;
	// }
	// return null;
	// }

	//
	public int numOfIgnoredZone = 0;
	public boolean isIgnored = false;

	//

	// public List<FireZone> fireZones = new ArrayList<FireZone>();
	//
	// public void updateFireZones() {
	// fireZones.clear();
	//
	// // FireZone
	// for (Iterator<Building> it = fires.iterator(); it.hasNext();) {
	// Building bd = it.next();
	// FireZone thisZone;
	// thisZone = getFireZoneOfBuilding(bd);
	// if (thisZone != null && !fireZones.contains(thisZone)) {
	// fireZones.add(thisZone);
	// }
	// }
	// }

	// generate direction in the fire site
	// ArrayList<Building> northDirection = new ArrayList<Building>();
	// ArrayList<Building> southDirection = new ArrayList<Building>();
	// ArrayList<Building> westDirection = new ArrayList<Building>();
	// ArrayList<Building> eastDirection = new ArrayList<Building>();
	//
	// DirectionSite northDirectionSite = null;
	// DirectionSite southDirectionSite = null;
	// DirectionSite westDirectionSite = null;
	// DirectionSite eastDirectionSite = null;
	//
	// public void generateDirection() {
	// northDirection.clear();
	// southDirection.clear();
	// westDirection.clear();
	// eastDirection.clear();
	//
	// northDirectionSite = null;
	// southDirectionSite = null;
	// westDirectionSite = null;
	// eastDirectionSite = null;
	//
	// final int x = m_Center.x;
	// final int y = m_Center.y;
	//
	// for (Iterator<Building> it = fires.iterator(); it.hasNext();) {
	// Building b = it.next();
	// int theta = 0;
	// theta = Util.normalizedDirection(x, y, b.getX(), b.getY());
	//
	// if (theta >= 45 && theta < 135) {
	// northDirection.add(b);
	// } else if (theta >= 135 && theta < 225) {
	// westDirection.add(b);
	// } else if (theta >= 225 && theta < 315) {
	// southDirection.add(b);
	// } else {
	// eastDirection.add(b);
	// }
	// }
	//
	// if (!northDirection.isEmpty())
	// northDirectionSite = new DirectionSite(northDirection);
	// if (!westDirection.isEmpty())
	// westDirectionSite = new DirectionSite(westDirection);
	//
	// if (!southDirection.isEmpty())
	// southDirectionSite = new DirectionSite(southDirection);
	// if (!eastDirection.isEmpty())
	// eastDirectionSite = new DirectionSite(eastDirection);
	// }
	//
	// /**
	// * @return the northDirectionSite
	// */
	// public DirectionSite getNorthDirectionSite() {
	// return northDirectionSite;
	// }
	//
	// /**
	// * @return the southDirectionSite
	// */
	// public DirectionSite getSouthDirectionSite() {
	// return southDirectionSite;
	// }
	//
	// /**
	// * @return the westDirectionSite
	// */
	// public DirectionSite getWestDirectionSite() {
	// return westDirectionSite;
	// }
	//
	// /**
	// * @return the eastDirectionSite
	// */
	// public DirectionSite getEastDirectionSite() {
	// return eastDirectionSite;
	// }

	// water need to extinguish fire site
	public int getWaterNeededToExtinguishFireSite() {
		return m_totalWaterNeededToExtinguish;
	}

	// water need to control fire site
	public int getWaterNeededToControlFireSite() {
		return m_totalWaterNeededToControl;
	}

	//

	/**
	 * Checks whether fire can be added to the site
	 * 
	 * @return 1, if have, 0 if can, -1 if cannot
	 */
	public int addFire(Building fire) {
		if (containsFire(fire)) {
			return 1;
		}
		if (!isSiteNeighbor(fire)) {
			return -1;
		}
		fires.add(fire);

		// m_containedZones.add(world.getState().zoneMap.get(fire));
		// m_zonesBuildings.addAll(world.getState().zoneMap.get(fire)
		// .getBuildings());

		siteNighbors.remove(fire);

		for (Building b : fire.getState().connectedBuildings) {
			if (!containsFire(b)) {
				siteNighbors.add(b);
			}
		}

		updateDangerousFires();
		return 0;
	}

	public void updateDangerousFires() {
		ArrayList burningBuildings = burningBuildings();
		dangerousFires.clear();
		dangerousFires.addAll(burningBuildings);
		for (Iterator it = dangerousFires.iterator(); it.hasNext();) {
			Building fire = (Building) it.next();
			ArrayList inDangerNeighbors = fire.getState().inDangerNeighbors();
			if (inDangerNeighbors == null || inDangerNeighbors.isEmpty()) {
				it.remove();
				continue;
			}
		}
	}

	public void mergeWith(FireSite fs) {
		fires.addAll(fs.fires);

		// m_containedZones.addAll(fs.m_containedZones);
		// m_zonesBuildings.addAll(fs.m_zonesBuildings);

		siteNighbors.addAll(fs.siteNighbors);
		Object[] temp = siteNighbors.toArray();
		for (int i = 0; i < temp.length; ++i) {
			if (fires.contains(temp[i])) {
				siteNighbors.remove(temp[i]);
			}
		}
		dangerousFires.addAll(fs.dangerousFires);
	}

	public HashSet getSiteNeibors() {
		return new HashSet(siteNighbors);
	}

	public ArrayList burnedDownBuildings() {
		ArrayList ret = new ArrayList();
		Object[] frs = fires.toArray();
		for (int i = 0; i < frs.length; ++i) {
			if (((Building) frs[i]).getFieryness() == 8)
				ret.add(frs[i]);
		}
		return ret;
	}

	public ArrayList<Building> burningBuildings() {
		return m_burningBuildings;
	}

	public float burningAreas() {
		return burningAreas;
	}

	public List<Building> getAllFires() {
		List<Building> allFires = new ArrayList<Building>(this.fires);
		return allFires;
	}

	public boolean containsFire(Building fire) {
		return fires.contains(fire);
	}

	public boolean isSiteNeighbor(Building b) {
		return siteNighbors.contains(b);
	}

	public ArrayList getFires() {
		ArrayList ret = new ArrayList();
		ret.addAll(fires);
		return ret;
	}

	public ArrayList dangerousFires() {
		ArrayList ret = new ArrayList();
		ret.addAll(dangerousFires);
		return ret;
	}

	// public FireZone getNearestFireZone(DisasterSpace world) {
	// float min = Float.MAX_VALUE;
	// FireZone nearest = null;
	// for (FireZone zone : world.fireZones) {
	// float dx = zone.x() - getX();
	// float dy = zone.y() - getY();
	//
	// float dis = dx * dx + dy * dy;
	// if (min > dis) {
	// min = dis;
	// nearest = zone;
	// }
	// }
	//
	// return nearest;
	// }

	private final Point m_Center = new Point();

	public void setCenter(int x, int y) {
		m_Center.x = x;
		m_Center.y = y;
	}

	public Point getCenter() {
		return m_Center;
	}

	public int getX() {
		return m_Center.x;

	}

	public int getY() {
		return m_Center.y;
	}

	public int distance(int x, int y) {
		return Util.distance(getX(), getY(), x, y);
	}

	public int totalFieryness_Area = 0;
	public int totalFieryness_Area_avg = 0;

	private final int m_totalWaterNeededToExtinguish = 0;
	private final int m_totalWaterNeededToControl = 0;

	private ArrayList<Building> m_burningBuildings = new ArrayList<Building>();

	public float m_expandRate = 0;

	public void updateSite(StandardWorldModel world) {
		totalFieryness = 0;
		totalArea = 0.0f;
		burningAreas = 0;
		totalAreasAvg = 0;
		m_totalFireStart = 0;
		totalFieryness_Area = 0;
		totalFieryness_Area_avg = 0;
		m_burningBuildings = new ArrayList<Building>();
		//
		totalFierinessArea = 0;

		// 
		// m_totalWaterNeededToExtinguish = 0;
		// m_totalWaterNeededToControl = 0;

		for (Object o : fires) {
			connectedPaths
					.addAll(((Building) o).getState().getContainedPaths(world));
			totalArea += ((Building) o).getTotalArea();
			if (((Building) o).getState().isBurning())
				m_burningBuildings.add((Building) o);
		}

		if (ignitTime > 3 || world.getState().burningBuildings.isEmpty())
			ignitTime = 1;

		if (!m_burningBuildings.isEmpty() && this.isPutOff
				&& !this.isIgnitionTimeSet) {
			this.isIgniteAgain = true;
			ignitTime++;
			this.isIgnitionTimeSet = true;
			this.burningTime = world.getState().getTime();
		}
		if (m_burningBuildings.isEmpty() && !isPutOffTimeSet) {
			this.isPutOff = true;
			this.isIgniteAgain = false;
			this.isIgnitionTimeSet = false;
			this.isPutOffTimeSet = true;
			this.putOffTime = world.getState().getTime();
			this.needColdDown = true;
			return;
		} else if (!m_burningBuildings.isEmpty()) {
			this.isPutOff = false;
			this.isPutOffTimeSet = false;
			this.needColdDown = false;
		} else {
			if (isPutOffTimeSet
					&& putOffTime < world.getState().getTime() - 2 - ignitTime)
				this.needColdDown = false;
			return;
		}

		calculateExpandRate();

		calculateCoordinates();

		for (Building bd : m_burningBuildings) {
			burningAreas += bd.getTotalArea();
			totalFieryness += bd.getFieryness();
			totalAreasAvg += bd.getTotalArea()
					/ WorldState.mapBuildingAreaAverage;
			totalFieryness_Area += (bd.getTotalArea() * bd.getFieryness()) / 3;
			totalFieryness_Area_avg += (bd.getTotalArea() * bd.getFieryness())
					/ WorldState.mapBuildingAreaAverage;

			// 2010 16:51 Knight
			// TODO 
			// m_totalWaterNeededToExtinguish += bd
			// .getWaterNeededToExtinguishFire();
			// if (bd.getFieryness() == 1)
			// m_totalWaterNeededToControl += bd
			// .getWaterNeededToExtinguishFire()
			// / ((bd.getFieryness() + 1) * (bd.getFieryness() + 1));

			totalFierinessArea += (bd.getTotalArea() * bd.getFieryness()) / 3;

		}
	}

	public void calculateExpandRate() {
		m_expandRate = 1;

		HashSet<Building> neibors = new HashSet<Building>();

		for (Building b : burningBuildings()) {
			neibors.addAll(b.getState().neighbourBuildings);
		}

		for (Building b : neibors) {
			if (b.getState().isBurning() || b.getState().isBurned())
				continue;

			if (b.getState().getFireCycle() < 15)
				m_expandRate++;

			// if (!m_zonesBuildings.contains(b))
			// m_expandRate += 0.8f;
		}

	}

	public float getTotalArea() {
		return totalArea;
	}

	public float getBurningArea() {
		return burningAreas;
	}

	public float getBurningAreaAvg() {
		return totalAreasAvg;
	}

	public int getTotalfieryness() {
		return totalFieryness;
	}

	public Building m_minXBuilding;
	public Building m_maxXBuilding;
	public Building m_minYBuilding;
	public Building m_maxYBuilding;

	public int m_maxX;
	public int m_maxY;
	public int m_minX;
	public int m_minY;

	public void calculateCoordinates() {

		m_maxX = Integer.MIN_VALUE;
		m_maxY = Integer.MIN_VALUE;
		m_minX = Integer.MAX_VALUE;
		m_minY = Integer.MAX_VALUE;

		for (Object o : this.burningBuildings()) {
			Building b = (Building) o;

			if (b.getX() > m_maxX) {
				m_maxX = b.getX();
				m_maxXBuilding = b;
			}

			if (b.getX() < m_minX) {
				m_minX = b.getX();
				m_minXBuilding = b;
			}

			if (b.getY() > m_maxY) {
				m_maxY = b.getY();
				m_maxYBuilding = b;
			}

			if (b.getY() < m_minY) {
				m_minY = b.getY();
				m_minYBuilding = b;
			}
		}

		float x = 0, y = 0;

		for (Building b : fires) {
			x += b.getX();
			y += b.getY();
		}

		try {
			x /= fires.size();
			y /= fires.size();
		} catch (Exception e) {
			// TODO: handle exception
		}
		setCenter((int) x, (int) y);

	}

	private int m_numberVictimsAround;

	public void setNumberVictimsAround(int victimNumber) {
		m_numberVictimsAround = victimNumber;
	}

	public int getNumberVictimsAround() {
		return m_numberVictimsAround;
	}

	private int m_directionOfExtinguish;

	public void setDirectionForExtinguish(int direction) {
		m_directionOfExtinguish = direction;
	}

	public int getDirectionForExtinguish() {
		return m_directionOfExtinguish;
	}

	private int m_totalFireStart;

	public int getTotalFireStart() {
		return m_totalFireStart;
	}

	public void setReachability(boolean reachability) {
		isReachable = reachability;
	}

	public boolean isReachable() {
		return isReachable;
	}

	public HashSet<Path> getConnectedPaths() {
		return connectedPaths;
	}

	public boolean needColdDown() {
		return needColdDown;
	}

	public void setNeedColdDown(boolean b) {
		needColdDown = b;
	}

	/**
	 * @return the siteValue
	 */
	public float getSiteValue() {
		return siteValue;
	}

	/**
	 * @param siteValue
	 *            the siteValue to set
	 */
	public void setSiteValue(float siteValue) {
		this.siteValue = siteValue;
	}

	public float m_totalConnectionValue = 0;

	public float m_value = 0;

	public float m_nearestFireCount = 0;

}
