package seu.utilities;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

import rescuecore2.standard.entities.Area;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.Building;
import rescuecore2.standard.entities.StandardWorldModel;
import rescuecore2.worldmodel.EntityID;
import seu.entities.Path;

public class Graph
{

	public int index;
	public List<Integer> edges;
	public List<Integer> vertices;
	public List<Building> buildings;

	public static double POWERFORAT_MAX = 5.0/180.0;
	public static double POWERFORAT_MIN = 3.5/180.0;
	public static double POWERFORFB_MAX = 1.0;
	public static double POWERFORFB_MIN = 1.0/3.0;
	
	// for evaluation:
	public int m_numOfAmbulanceTeam=0;
	public int m_numOfFireBrigade = 0;
	public int m_numOfPoliceForce = 0;
	public int m_numOfCivilian = 0;
	public double m_totalCivValue = 0;
	public int m_numOfBurningBuilding = 0;
	public int m_totalAreaOfBurningBuilding = 0;
	public int m_numRefuge = 0;
	
	public int m_minATNeeded = 0;
	public int m_maxATNeeded = 0;
	public int m_minFBNeeded = 0;
	public int m_maxFBNeeded = 0;

	
	public Graph()
	{
		edges = new ArrayList<Integer>();
		vertices = new ArrayList<Integer>();
		buildings = new ArrayList<Building>();
	}
	
	
	public void evaluateGraphFlows(int time)
	{
		// for AT
		double atWork = m_numOfCivilian + m_totalCivValue;
		double x = atWork/((double)(300-time))/((double)POWERFORAT_MAX);
		m_minATNeeded = (int)x;
		x = atWork/((double)(300-time))/((double)POWERFORAT_MIN);
		m_maxATNeeded = (int)x;
		// for FB
		x = ((double)m_numOfBurningBuilding)/POWERFORFB_MAX;
		m_minFBNeeded = (int)x;
		x = ((double)m_numOfBurningBuilding)/POWERFORFB_MIN;
		m_maxFBNeeded = (int)x;
	}
	
	public boolean isContains(Area ar, StandardWorldModel model){
		if(ar instanceof Road)
			if (vertices.contains(ar))
			return true;
		if(ar instanceof Building){
			for(Integer p:edges)
				if(model.getState().paths.get(p.intValue()).getConnectedBuildings().contains((Building)ar))
						return true;
		}		
		return false;
	}
	
	
}