package seu.utilities;

import java.util.LinkedList;

import seu.utilities.base.SingleData;


/**
 * Message Manager for SBCe_Saviour 2006
 * by Maryam Kalantary
 *
 **/
public class MessageUtil
{
    public static boolean copyArray(char[] src, char[] des, int srcBegin, int desBegin, int len)
    {
        if (srcBegin + len > src.length || desBegin + len > des.length)
        {
            return false;
        }

        for (int i = srcBegin, j = desBegin, k = 0; k < len; k++, i++, j++)
        {
            des[j] = src[i];
        }
        return true;
    }

    public static char[] intToCharArray(int value, int length)
    {
        char[] result = new char[length];
        //TODO: bar aksesh kardam
        for (int i = length - 1; i >= 0; i--)
        {
            result[length - i - 1] = (value & 1) == 1 ? '1' : '0';
            value = (int) (value >> 1);
        }
        return result;
    }

    public static int charArrayToint(char[] array, int begin, int length)
    {
        int result = 0;
        int end = begin + length - 1;

        for (int i = end; i >= begin; i--)
        {
            result = (int) (result << 1);
            if (array[i] == '1')
            {
                result++;
            }
        }

        return result;
    }

	public static <T> T searchSingleDataForTime(LinkedList<SingleData<T>> list,
			int time)
	{
		int left = 0, right = list.size() - 1;

		if (time <= list.getFirst().getTime())
			return list.getFirst().getObject();

		if (time >= list.getLast().getTime())
			return list.getLast().getObject();

		while (true)
		{
			int location = (left + right) / 2;
			int locationTime = list.get(location).getTime();

			if (location == list.size() - 1 && locationTime < time)
				return list.get(location).getObject();

			int locationTimeNext = list.get(location + 1).getTime();
			if (locationTime < time && locationTimeNext > time)
				return list.get(location).getObject();

			if (locationTime > time)
				right = location - 1;
			else if (locationTime < time)
				left = location + 1;
			else
				return list.get(location).getObject();
		}

	}

}
