// Edited By Omid Aghazadeh
// Edited by Nobel Huang
package seu.utilities;

public abstract class SimulatorsConstants {
	public static final int SIMULATING_TIME = 300;

	public static int MAX_WATER_QUANTITY = 15000;

	/** The fire simulator starts simulation at 1st-cycle */
	public static final int TIME_STARTING_FIRE = 1 + 1;

	/** Buildings' state are set by the blockade simulator at 1st-cycle */
	public static final int TIME_SIMULATED_BLOCKADE = 1 + 1;

	/**
	 * Roads' state are set by the collapse simulator by using the property
	 * brokenness simulated
	 */
	public static final int TIME_SIMULATED_COLLAPSE = TIME_SIMULATED_BLOCKADE + 1;

	public static final int TIME_SIMULATED_INITIAL_STATE_OF_DISASTER_SPACE = TIME_SIMULATED_COLLAPSE;

	public static final int AGENT_INITIALIZING_TIME = Integer.MIN_VALUE;

	/** Individual agent gets within a radius of VISIBLE_DISTANCE by KA_SENSE */
	public static final int VISIBLE_DISTANCE = 10000;
	
	/** Individual agent gets within a radius of HEARABLE_DISTANCE by KA_HEAR */
	public static final int HEARABLE_DISTANCE = 30000;

	/**
	 * The FireBrigade can extinguish fire with a radius of
	 * EXTINGUISHABLE_QUANTITY [mm].
	 */
	public static final int EXTINGUISHABLE_DISTANCE = 60000;

	/**
	 * The FireBrigade can extinguish with warter EXTINGUISHABLE_QUANTITY [0.001
	 * m^3 / minute].
	 */
//	public static final int EXTINGUISHABLE_QUANTITY = 1000;
	
	public static final int FIRE_COGNITION_SPREADING_SPEED = 10000;

	/**
	 * width [mm] which one PoliceForce repair by AK_CLEAR. cf.
	 * blockadessimulator, main.cxx, block_param, commands()
	 */
//	public static final int REPAIRING_WIDTH_BY_CLEARING = 1000;
//
//	public static final int INITIAL_HP = 10000;

	/** Civilian whoes damage is CIVILIAN_UNACTABLE_DAMAGE or more cannot act */
	public static final int CIVILIAN_UNACTABLE_DAMAGE = 1;

	public static final int MAX_MESSAGE_NUMBER_ADMITTED_SPEAKING = 4;

	public static final int MAX_MESSAGE_NUMBER_ADMITTED_SPEAKING_CENTER = 20;

	public static final double MAX_ROAD_LENGTH = Integer.MAX_VALUE + (double) 1;
	
	//define the log directory
	public static final String LOGDIR = System.getenv("HOME")==null?"/logs":System.getenv("HOME")+"/logs";

}
